/*
DESCRIPTION:
Any functions that are used internally by the use-case
*/
package soapi

import (
	e "simrs-vx/internal/domain/main-entities/soapi"
)

func setData[T *e.CreateDto | *e.UpdateDto](input T, data *e.Soapi) {
	var inputSrc *e.CreateDto
	if inputT, ok := any(input).(*e.CreateDto); ok {
		inputSrc = inputT
	} else {
		inputTemp := any(input).(*e.UpdateDto)
		inputSrc = &inputTemp.CreateDto
	}

	data.Encounter_Id = inputSrc.Encounter_Id
	data.Employee_Id = inputSrc.Employee_Id
	data.Time = inputSrc.Time
	data.TypeCode = inputSrc.TypeCode
	data.Value = inputSrc.Value
}

func setBulkData(input []e.CreateDto, encounterId uint) []e.Soapi {
	var data []e.Soapi

	for _, v := range input {
		data = append(data, e.Soapi{
			Encounter_Id: &encounterId,
			Employee_Id:  v.Employee_Id,
			Time:         v.Time,
			TypeCode:     v.TypeCode,
			Value:        v.Value,
		})
	}

	return data
}
